Properties Methods Events Config Options Direct Link

    Observable
      AbstractSelectionModel
        CellSelectionModel

# Class Ext.grid.CellSelectionModel

Package: | Ext.grid
Defined In: | CellSelectionModel.js
Class: | CellSelectionModel
Extends: | AbstractSelectionModel

This class provides the basic implementation for single cell selection in a grid. The object stored as the selection and returned by getSelectedCell contains the following properties:

- record : Ext.data.record

  The Record which provides the data for the row containing the selection

- cell : Ext.data.record

  An object containing the following properties:

  - rowIndex : Number

    The index of the selected row

  - cellIndex : Number

    The index of the selected cell
    Note that due to possible column reordering, the cellIndex should not be used as an index into the Record's data. Instead, the name of the selected field should be determined in order to retrieve the data value from the record by name:

        var fieldName = grid.getColumnModel().getDataIndex(cellIndex);
            var data = record.get(fieldName);

## Config Options

Config Options | Defined By
--- | ---
| listeners : Object A config object containing one or more event handlers to be added to this object during initialization. This should b... A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once. | Observable

## Public Properties

This class has no public properties.

## Public Methods

Method | Defined By
--- | ---

CellSelectionModel( `Object config` )
Parameters:

- `config` : Object
  The object containing the configuration of this model.

Returns:

- ``

CellSelectionModel

addEvents( `Object object` ) : void
Used to define events on this Observable
Used to define events on this Observable
Parameters:

- `object` : Object
  The object with the events defined

Returns:

- `void`

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this component
Appends an event handler to this component
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional) An object containing handler configuration properties. This may contain any of the following properties:
  - scope : Object

    The scope in which to execute the handler function. The handler function's "this" context.

  - delay : Number

    The number of milliseconds to delay the invocation of the handler after the event fires.

  - single : Boolean

    True to add a handler to handle just the next firing of the event, and then remove itself.

  - buffer {Number} Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A normalized, delayed, one-time listener that auto stops the event and passes a custom argument (forumId)

      el.on('click', this.onClick, this, {
          single: true,
          delay: 100,
          forumId: 4
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      foo.on({
          'click' : {
              fn: this.onClick,
              scope: this,
              delay: 100
          },
          'mouseover' : {
              fn: this.onMouseOver,
              scope: this
          },
          'mouseout' : {
              fn: this.onMouseOut,
              scope: this
          }
      });

  Or a shorthand syntax:

      foo.on({
          'click' : this.onClick,
          'mouseover' : this.onMouseOver,
          'mouseout' : this.onMouseOut,
           scope: this
      });

Returns:

- `void`

Observable

clearSelections( `Boolean true` ) : void
Clears all selections.
Clears all selections.
Parameters:

- `true` : Boolean
  to prevent the gridview from being notified about the change.

Returns:

- `void`

CellSelectionModel

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name).
Fires the specified event with the passed parameters (minus the event name).
Parameters:

- `eventName` : String
- `args` : Object...
  Variable number of parameters are passed to handlers

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true

Observable

getSelectedCell() : Object
Returns the currently selected cell,.
Returns the currently selected cell,.
Parameters:

- None.

Returns:

- `Object`
  The selected cell or null if none selected.

CellSelectionModel

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

hasSelection() : Boolean
Returns true if there is a selection.
Returns true if there is a selection.
Parameters:

- None.

Returns:

- `Boolean`

CellSelectionModel

isLocked() : Boolean
Returns true if the selections are locked.
Returns true if the selections are locked.
Parameters:

- None.

Returns:

- `Boolean`

AbstractSelectionModel

lock() : void
Locks the selections.
Locks the selections.
Parameters:

- None.

Returns:

- `void`

AbstractSelectionModel

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this element (shorthand for addListener)
Appends an event handler to this element (shorthand for addListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional)

Returns:

- `void`

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- `void`

Observable

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener
Removes a listener
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

resumeEvents() : void
Resume firing events. (see suspendEvents)
Resume firing events. (see suspendEvents)
Parameters:

- None.

Returns:

- `void`

Observable

select( `Number rowIndex`, `Number collIndex` ) : void
Selects a cell.
Selects a cell.
Parameters:

- `rowIndex` : Number
- `collIndex` : Number

Returns:

- `void`

CellSelectionModel

suspendEvents() : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- None.

Returns:

- `void`

Observable

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener (shorthand for removeListener)
Removes a listener (shorthand for removeListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

unlock() : void
Unlocks the selections.
Unlocks the selections.
Parameters:

- None.

Returns:

- `void`

AbstractSelectionModel

## Public Events

Event | Defined By
--- | ---

beforecellselect : ( `SelectionModel this`, `Number rowIndex`, `Number colIndex` )
Fires before a cell is selected.
Fires before a cell is selected.
Listeners will be called with the following arguments:

- `this` : SelectionModel
- `rowIndex` : Number
  The selected row index
- `colIndex` : Number
  The selected cell index

CellSelectionModel

cellselect : ( `SelectionModel this`, `Number rowIndex`, `Number colIndex` )
Fires when a cell is selected.
Fires when a cell is selected.
Listeners will be called with the following arguments:

- `this` : SelectionModel
- `rowIndex` : Number
  The selected row index
- `colIndex` : Number
  The selected cell index

CellSelectionModel

selectionchange : ( `SelectionModel this`, `Object selection` )
Fires when the active selection changes.
Fires when the active selection changes.
Listeners will be called with the following arguments:

- `this` : SelectionModel
- `selection` : Object
  null for no selection or an object (o) with two properties
  - o.record: the record object for the row the selection is in
  - o.cell: An array of [rowIndex, columnIndex]

CellSelectionModel